<template>
    <form @submit.prevent="createTask()">
        <div class="form-group" v-if="!disabled">
            <label>Tasks</label>
            
                <div class="input-group">
                    <input
                        v-model="task.name"
                        type="text"
                        ref="taskName"
                        class="form-control"
                        autofocus
                        autocomplete="off"
                    />
                    <span class="input-group-btn">
                        <input type="submit" class="btn btn-primary" value="New Task" />
                    </span>
                </div>
            
        </div>

        <div class="text-center" v-if="tasks.length === 0">
            <p>There are no tasks yet!</p>
        </div>

        <table class="table table-sm table-bordered">
            <tbody>
                <tr v-bind:key="index" v-for="(task, index) in tasks">
                    <td class="text-center align-middle" style="width: 80%;">
                        <span
                            v-bind:style="[
                                task.completed
                                    ? { 'text-decoration': 'line-through' }
                                    : {}
                            ]"
                            ><input type="text"
                                class="form-control" v-model="task.name" :readonly="disabled"></span
                        >
                    </td>
                    <td class="text-center align-middle" style="width: 10%;" v-if="!disabled">
                        <input
                            type="checkbox"
                            v-model="task.completed"
                            autocomplete="off"
                        />
                    </td>
                    <td class="text-center align-middle" style="width: 10%;" v-if="!disabled">
                        <button
                            @click="deleteTask(index, task.name)"
                            class="btn btn-sm pull-right"
                            type="button"
                        >
                            <i class="fa fa-times" aria-hidden="true"></i>
                        </button>
                    </td>
                </tr>
            </tbody>
        </table>
    </form>
</template>

<script>
export default {
    props: ['tasks', 'disabled'],
    data() {
        return {
            task: {
                name: "",
                completed: false
            }
        };
    },

    created() {

    },

    methods: {
        createTask() {
            if (this.task.name) {
                this.tasks.push({ ...this.task });
                this.$emit('addTodoList', this.tasks);
                this.task.name = "";
            } 

            this.$refs.taskName.focus();
        },

        deleteTask(index, taskName) {
            this.tasks.splice(index, 1);
            this.$emit('deleteTask', taskName);
            this.$refs.taskName.focus();
        }
    }
};
</script>
